package net.kelsoncraft.test.item;

import net.fabricmc.fabric.api.itemgroup.v1.FabricItemGroup;
import net.kelsoncraft.test.KelsonCraftTest;
import net.kelsoncraft.test.block.CustomBlocks;
import net.minecraft.item.ItemGroup;
import net.minecraft.item.ItemStack;
import net.minecraft.item.Items;
import net.minecraft.registry.Registries;
import net.minecraft.registry.Registry;
import net.minecraft.text.Text;
import net.minecraft.util.Identifier;

public class CustomItemGroups {

    // This adds the items to a custom item group in the creative menu.
    public static final ItemGroup CUSTOM_GROUP = Registry.register(Registries.ITEM_GROUP,
            new Identifier(KelsonCraftTest.MOD_ID, "custom_items"),
            FabricItemGroup.builder().displayName(Text.translatable("itemgroup.custom"))
                    .icon(() -> new ItemStack(CustomItems.RUBY)).entries((displayContext, entries) -> {
                        // Custom items
                        entries.add(CustomItems.RUBY);
                        entries.add(CustomItems.RAW_RUBY);
                        entries.add(CustomItems.CUSTOM_ITEM);

                        // Custom blocks
                        entries.add(CustomBlocks.RUBY_BLOCK);
                        entries.add(CustomBlocks.RAW_RUBY_BLOCK);
                        entries.add(CustomBlocks.RUBY_ORE);
                        entries.add(CustomBlocks.DEEPSLATE_RUBY_ORE);
                        entries.add(CustomBlocks.NETHER_RUBY_ORE);
                        entries.add(CustomBlocks.END_STONE_RUBY_ORE);

                        // Vanilla items can be added to this group also
                        //entries.add(Items.DIAMOND);
                    }).build());

    public static void registerItemGroups(){
        KelsonCraftTest.LOGGER.info("Registering item groups for " + KelsonCraftTest.MOD_ID);
    }
}
